//+------------------------------------------------------------------+
//|                                                    Trade_BUY.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#include <stdlib.mqh>
//+------------------------------------------------------------------+
//| script "trading for all money"                                   |
//+------------------------------------------------------------------+
int start()
  {
//----
   int error = 0;
   string txt_s = "";
   if(ObjectFind("txt_status") < 0)
     {
      if(!ObjectCreate("txt_status", OBJ_LABEL, 0, 0, 0))
       {
         Print(" = ",ErrorDescription(GetLastError()));
         return(0);
       }
      ObjectSet("txt_status", OBJPROP_CORNER, 3);
      ObjectSet("txt_status", OBJPROP_XDISTANCE, 7);
      ObjectSet("txt_status", OBJPROP_YDISTANCE, 7);
     }
   if (MarketInfo(Symbol(), MODE_TRADEALLOWED) != 1.0)
     {
      info("    .", Red, true);
      return(0);
     }
   double mi_minlot = MarketInfo(Symbol(), MODE_MINLOT);
   if(mi_minlot <= 0.0)
     {
      error=GetLastError();
      info(StringConcatenate(" = " , ErrorDescription(error)), Red, true);
      return(0);
     }
   if(!GlobalVariableCheck("gv_LotSize")) GlobalVariableSet("gv_LotSize", mi_minlot);
   double gv_v = GlobalVariableGet("gv_LotSize");
   
   if(!GlobalVariableCheck("gv_StopLoss")) GlobalVariableSet("gv_StopLoss", 20);
   double gv_sl = GlobalVariableGet("gv_StopLoss");
   
   if(!GlobalVariableCheck("gv_TakeProfit")) GlobalVariableSet("gv_TakeProfit", 30);
   double gv_tp = GlobalVariableGet("gv_TakeProfit");
   
   if(!GlobalVariableCheck("gv_Repeat_Count")) GlobalVariableSet("gv_Repeat_Count", 10);
   int gv_i = GlobalVariableGet("gv_Repeat_Count");
   if (gv_i < 0) gv_i = 0;
   
   if(!GlobalVariableCheck("gv_Vremya_Ojidaniya_MillSec")) GlobalVariableSet("gv_Vremya_Ojidaniya_MillSec", 100);
   int gv_t = GlobalVariableGet("gv_Vremya_Ojidaniya_MillSec");
   if (gv_t < 100) gv_t = 100;
   gv_t = gv_t / 100;
   int t = 0;
   int ticket = -1;
   for(int i = 0; i <= gv_i; i++)
     {
      for(t = t; t <= gv_t; t++)
         {
          RefreshRates();
          if (IsTradeContextBusy())
           {
            if (t == gv_t) 
             {
              info(StringConcatenate("  .", gv_t / 10, "."), Red, true);
              return(0);
             }
           }
          else
           {
            break;
           }
          Sleep(100);
          RefreshRates();
         }
      ticket = OrderSend(Symbol(), OP_SELL, gv_v, NormalizeDouble(Bid, Digits), 3, NormalizeDouble(Ask + gv_sl * Point, Digits), NormalizeDouble(Bid - gv_tp * Point, Digits), NULL, 0, 0, Red);
      if(ticket < 0)
        {
         error=GetLastError();
         info(StringConcatenate(" = " , ErrorDescription(error)), Red, true);
        }
      else
        {
         OrderSelect(ticket, SELECT_BY_TICKET);
         info(StringConcatenate("SELL " , OrderLots() , " " , OrderSymbol() , "  " , OrderOpenPrice() , " SL: " , OrderStopLoss(), " TP: " , OrderTakeProfit() , " OK"), Lime, false);
         error=0;
        }
       switch(error)
         {
          case 135:  break;
          case 136:  break;
          case 137:  break;
          case 138:  break;
          default:   return(0);
         }
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+
int info(string txt, color clr, bool isp)
  {
   ObjectSetText("txt_status", StringConcatenate(TimeToStr(TimeCurrent(), TIME_SECONDS), ": " , txt));
   ObjectSet("txt_status",OBJPROP_COLOR, clr);
   if (isp) Print(txt);
   return(0);
  }