//+------------------------------------------------------------------+
//|                                                        close.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#include <stdlib.mqh>
//+------------------------------------------------------------------+
//| script "close first market order if it is first in the list"     |
//+------------------------------------------------------------------+
int start()
  {
   bool   result;
   double price;
   int    cmd;
   int error = 0;
   string txt_s = "";
   
   if(!GlobalVariableCheck("gv_Repeat_Count")) GlobalVariableSet("gv_Repeat_Count", 10);
   int gv_i = GlobalVariableGet("gv_Repeat_Count");
   if (gv_i < 0) gv_i = 0;
   
   if(ObjectFind("txt_status") < 0)
     {
      if(!ObjectCreate("txt_status", OBJ_LABEL, 0, 0, 0))
       {
         error=GetLastError();
         Print(" = ",ErrorDescription(error));
         return(0);
       }
      ObjectSet("txt_status", OBJPROP_CORNER, 3);
      ObjectSet("txt_status", OBJPROP_XDISTANCE, 7);
      ObjectSet("txt_status", OBJPROP_YDISTANCE, 7);
     }
//----
   int total = OrdersTotal();
   bool flag = false;
   double profit = 0.0;
   int t = 0;
   for (int k = 0; k < total; k++)
     {
      if(OrderSelect(k,SELECT_BY_POS,MODE_TRADES))
        {
         if (OrderSymbol()!=Symbol()) continue;
         cmd=OrderType();
         //---- first order is buy or sell
         if(cmd==OP_BUY || cmd==OP_SELL)
           {
            flag = true;
            for(int i=0; i <= gv_i; i++)
              {
               RefreshRates();
               if(cmd==OP_BUY) price=NormalizeDouble(Bid, Digits);
               else            price=NormalizeDouble(Ask, Digits);
               result=OrderClose(OrderTicket(), OrderLots(), price, 3, White);
               if(result!=TRUE)
                {
                 error=GetLastError();
                 info(StringConcatenate(" = ", ErrorDescription(error)), Red, true);
                }
               else
                {
                 t++;
                 profit += OrderProfit();
                 error=0;
                }
               bool v = false;
               switch(error)
                 {
                  case 135:  break;
                  case 136:  break;
                  case 137:  break;
                  case 138:  break;
                  default:   v = true;
                 }
               if (v) break;
              }
           }
        }
     }
   if (flag)
     {
      info(StringConcatenate(" : ", t,".  : ", profit), Lime, true);
     }
   if (!flag)
     {
         error = GetLastError();
         if (error > 1)
           {
            info(StringConcatenate(" = ", ErrorDescription(error)), Red, true);
           }
         else
           {
            info("  ", Red, true);
           }
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+
int info(string txt, color clr, bool isp)
  {
   ObjectSetText("txt_status", StringConcatenate(TimeToStr(TimeCurrent(), TIME_SECONDS), ": " , txt));
   ObjectSet("txt_status",OBJPROP_COLOR, clr);
   if (isp) Print(txt);
   return(0);
  }